/*  Copyright (C) 2023 Tibor 'Igor2' Palinkas - license: Creative Commons CC0 */

#include <stdlib.h>
#include <stdio.h>
#include "input.c"

float *state1, *state2, *input_temps;

void pre_iterate(float *state, const float *input, long SX, long SY)
{
	long n, len = SX*SY;
	for(n = 0; n < len; n++,state++,input++)
		if (*input != 0)
			*state = *input;
}

void iterate(float *new_st, const float *old_st, long SX, long SY)
{
	long x, y, idx;
	for(y = 1; y < SY-1; y++) {
		idx = y * SX + 1;
		for(x = 1; x < SX-1; x++,idx++) {
			new_st[idx] = (old_st[idx-1] + old_st[idx+1] + old_st[idx-SX] + old_st[idx+SX])/4.0;
		}
	}
}


int main()
{
	int n, its = 1000;
	long SX=1000, SY=1000;


	state1 = calloc(sizeof(float), SX*SY);
	state2 = calloc(sizeof(float), SX*SY);
	input_temps = calloc(sizeof(float), SX*SY);
	gen_input(input_temps, SX, SY);

	printf("--- initial:\n");
	pre_iterate(state1, input_temps, SX, SY);
	print_mx(state1, SX, SY);

	for(n = 0; n < its; n++) {
		pre_iterate(state1, input_temps, SX, SY);
		iterate(state2, state1, SX, SY);
		pre_iterate(state2, input_temps, SX, SY);
		iterate(state1, state2, SX, SY);
	}

	printf("--- result:\n");
	pre_iterate(state1, input_temps, SX, SY);
	print_mx(state1, SX, SY);
}
