/*
    libgpcogl - Generic Purpose Computation on OpenGL (using shaders)
    Copyright (C) 2023 Tibor 'Igor2' Palinkas

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

    Contact:
      Project page: http://www.repo.hu/projects/libgpcogl
      Lead developer: http://www.repo.hu/projects/libgpcogl/contact.html
*/

/* Call this once before anything else */
void gpcogl_gli_init(int *argc, char *argv[]);

/* Call this at the end to undo gpcogl_gli_init() and free all memory */
void gpcogl_gli_uninit(void);

/* Create a context for off-line rendering */
int gpcogl_gli_make_context(gpcogl_t *ctx, const char *option);

/* Destroy a context previously created using gpcogl_gli_make_context() */
void gpcogl_gli_destroy_context(gpcogl_t *ctx);

/* Create a debug context for rendering into a visible window; wsx and wsy
   must match the size of the output array */
int gpcogl_gli_make_context_window(gpcogl_t *ctx, int wsx, int wsy);

